Subject: Re: cw1200: Fix a sleep-in-atomic bug in cw1200_tx_confirm_cb and cw1200_cqm_bssloss_sm

From: Kalle Valo <[email-masked]>
Date: Thu, 1 Jun 2017 09:48:25 +0000 (UTC)

Jia-Ju Bai <[email-masked]> wrote:

> The driver may sleep under a spin lock, and the function call path is:
> cw1200_tx_confirm_cb (acquire the lock by spin_lock)
>   __cw1200_cqm_bssloss_sm
>     cancel_work_sync --> may sleep
> 
> cw1200_cqm_bssloss_sm
>   __cw1200_cqm_bssloss_sm
>     cancel_work_sync --> may sleep
> 
> To fix it, the lock is released before cancel_work_sync, and the lock 
> is acquired again after this function.
> 
> Signed-off-by: Jia-Ju Bai <[email-masked]>

I assume that you haven't tested this on a real device and only compile tested.
You should mention that in the commit log.

Releasing a lock held by calling function is evil. Did you do any lock analysis
or are you just blindly releasing locks to fix a warning in your tool?

Also I would like to have an ack from a reviewer before I can take patches like
this.

Patch set to Changes Requested.

-- 
https://patchwork.kernel.org/patch/9758613/

https://wireless.wiki.kernel.org/en/developers/documentation/submittingpatches